<template>
    <div>
        <Head title="Password"/>
        <v-card dense rounded>
            <v-card dense rounded>
                <v-card-title class="text-subtitle-1 font-weight-bold">
                    <v-icon left color="primary">mdi-lock-outline</v-icon>
                    Password
                    <v-spacer/>
                </v-card-title>
            </v-card>
        </v-card>
        <v-divider class="my-2"/>
        <v-card elevation="3">
            <v-card-text>
                <v-form class="mt-3">
                    <v-row justify="center">
                        <v-col md="6">
                            <v-text-field label="Enter current password" v-model="form.old_password" :loading="loading"
                                          :error-messages="error.old_password"
                                          type="password" outlined dense></v-text-field>
                            <v-text-field label="Enter new password" v-model="form.password" type="password"
                                          :loading="loading"
                                          :error-messages="error.password" outlined dense></v-text-field>
                            <v-text-field label="Enter new password again" v-model="form.password_confirmation"
                                          type="password" :loading="loading" outlined dense></v-text-field>
                        </v-col>
                        <v-col cols="12" align="center">
                            <!-- @todo reset password -->
                            <a href="">Forgotten password? Reset it.</a>
                        </v-col>
                    </v-row>
                </v-form>
                <v-divider/>
            </v-card-text>
            <v-card-actions>
                <v-row>
                    <v-spacer/>
                    <v-col align="end">
                        <v-btn class="" text small :loading="loading" @click="resetPassword" color="primary">
                            Update Password
                            <v-icon right>mdi-content-save-outline</v-icon>
                        </v-btn>
                    </v-col>
                </v-row>
            </v-card-actions>
        </v-card>
    </div>
</template>

<script>
import Settings from "../../../Components/Layouts/Settings.vue";
import Setting from "../Setting.vue";

export default {
    old_password: "Password", // @todo Likely an error
    layout: [Settings, Setting],
    data() {
        return {
            loading: false,
            rules: [
                value => !!value || 'Please fill this field.'
            ],
            error: {
                old_password: [],
                password: [],
            },
            form: {
                old_password: '',
                password: '',
                password_confirmation: ''
            },
            eventSubscription: null

        }
    },
    methods: {
        clearError() {
            for (let i in this.error) {
                this.error[i] = []
            }
        },
        resetPassword() {
            //check if oldpassword === authuser password
            if (this.form.new_password_first === this.form.new_password_second) {
                this._confirmDialog({
                    message: 'Are you sure you want to reset your password?',
                    confirm: () => {
                        this.$inertia.put(this.$route('user.reset_password', this.$page.props.auth.user.id), this.form, {
                            onBefore: () => {
                                this.loading = true
                            },
                            onSuccess: (page) => {
                                this.showSnack(["Password has been reset"])
                            },
                            onError: (errors) => {
                                console.log(errors)
                                if (errors && Object.values(errors).length) {
                                    this.showSnack([Object.values(errors)[0], "error"])
                                }
                            },
                            onFinish: visit => {
                                this.loading = false
                            },
                        });
                    }
                })
            } else {
                this.showSnack(['Passwords do not match', 'error'])
            }
        }

    },
    mounted() {
    }
}
</script>

<style>

</style>
